# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.networking.v4.config.AuthorizationData import AuthorizationData  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.AzureExternalSubnetConfig import AzureExternalSubnetConfig  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.BgpInfo import BgpInfo  # noqa: F401,E501

class AzureConfig(object):

    """Azure configuration.

    :param external_subnet_config_list: (:attr:`external_subnet_config_list`) The external subnet configuration list for the Azure cloud.
    :type external_subnet_config_list: required
    
    
    :param external_routing_domain_uuid_list: (:attr:`external_routing_domain_uuid_list`) External routing domain UUID list.
    :type external_routing_domain_uuid_list: 
    
    
    :param bgp_info: (:attr:`bgp_info`) 
    :type bgp_info: 
    
    
    :param is_scale_out: (:attr:`is_scale_out`) True if flow gateway scale out is supported. (**Default** False)
    :type is_scale_out: 
    
    
    :param authorization_data: (:attr:`authorization_data`) 
    :type authorization_data: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'external_subnet_config_list': 'list[networking.v4.config.AzureExternalSubnetConfig]',
        'external_routing_domain_uuid_list': 'list[str]',
        'bgp_info': 'networking.v4.config.BgpInfo',
        'is_scale_out': 'bool',
        'authorization_data': 'networking.v4.config.AuthorizationData',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'external_subnet_config_list': 'externalSubnetConfigList',
        'external_routing_domain_uuid_list': 'externalRoutingDomainUuidList',
        'bgp_info': 'bgpInfo',
        'is_scale_out': 'isScaleOut',
        'authorization_data': 'authorizationData',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, external_subnet_config_list=None, external_routing_domain_uuid_list=None, bgp_info=None, is_scale_out=False, authorization_data=None, *args, **kwargs):  # noqa: E501
        self.__external_subnet_config_list = None
        self.__external_routing_domain_uuid_list = None
        self.__bgp_info = None
        self.__is_scale_out = None
        self.__authorization_data = None
        self.discriminator = None
        self.__external_subnet_config_list = external_subnet_config_list
        if external_routing_domain_uuid_list is not None:
            self.__external_routing_domain_uuid_list = external_routing_domain_uuid_list
        if bgp_info is not None:
            self.__bgp_info = bgp_info
        if is_scale_out is not None:
            self.__is_scale_out = is_scale_out
        if authorization_data is not None:
            self.__authorization_data = authorization_data
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.AzureConfig'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def external_subnet_config_list(self):
        """
        The external subnet configuration list for the Azure cloud.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.networking.v4.config.AzureExternalSubnetConfig` ]
        """  # noqa: E501
        return self.__external_subnet_config_list

    @external_subnet_config_list.setter
    def external_subnet_config_list(self, external_subnet_config_list):
        if external_subnet_config_list is None:
            raise ValueError("Invalid value for `external_subnet_config_list`, must not be `None`")  # noqa: E501

        self.__external_subnet_config_list = external_subnet_config_list

    @property
    def external_routing_domain_uuid_list(self):
        """
        External routing domain UUID list.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__external_routing_domain_uuid_list

    @external_routing_domain_uuid_list.setter
    def external_routing_domain_uuid_list(self, external_routing_domain_uuid_list):

        self.__external_routing_domain_uuid_list = external_routing_domain_uuid_list

    @property
    def bgp_info(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.BgpInfo`
        """  # noqa: E501
        return self.__bgp_info

    @bgp_info.setter
    def bgp_info(self, bgp_info):

        self.__bgp_info = bgp_info

    @property
    def is_scale_out(self):
        """
        True if flow gateway scale out is supported.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_scale_out

    @is_scale_out.setter
    def is_scale_out(self, is_scale_out):

        self.__is_scale_out = is_scale_out

    @property
    def authorization_data(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.AuthorizationData`
        """  # noqa: E501
        return self.__authorization_data

    @authorization_data.setter
    def authorization_data(self, authorization_data):

        self.__authorization_data = authorization_data

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AzureConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AzureConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

