# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.BgpSession import BgpSession  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Gateway import Gateway  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.GatewayProjection import GatewayProjection  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Status import Status  # noqa: F401,E501

class BgpSessionProjection(BgpSession):

    """

    :param gateway_projection: (:attr:`gateway_projection`) 
    :type gateway_projection: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'gateway_projection': 'networking.v4.config.GatewayProjection',
        'name': 'str',
        'description': 'str',
        'local_gateway_reference': 'str',
        'remote_gateway_reference': 'str',
        'local_gateway_interface_ip_address': 'common.v1.config.IPAddress',
        'dynamic_route_priority': 'int',
        'password': 'str',
        'status': 'networking.v4.config.Status',
        'local_gateway': 'networking.v4.config.Gateway',
        'remote_gateway': 'networking.v4.config.Gateway',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'gateway_projection': 'gatewayProjection',
        'name': 'name',
        'description': 'description',
        'local_gateway_reference': 'localGatewayReference',
        'remote_gateway_reference': 'remoteGatewayReference',
        'local_gateway_interface_ip_address': 'localGatewayInterfaceIpAddress',
        'dynamic_route_priority': 'dynamicRoutePriority',
        'password': 'password',
        'status': 'status',
        'local_gateway': 'localGateway',
        'remote_gateway': 'remoteGateway',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, gateway_projection=None, name=None, description=None, local_gateway_reference=None, remote_gateway_reference=None, local_gateway_interface_ip_address=None, dynamic_route_priority=None, password=None, status=None, local_gateway=None, remote_gateway=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        BgpSession.__init__(self, name, description, local_gateway_reference, remote_gateway_reference, local_gateway_interface_ip_address, dynamic_route_priority, password, status, local_gateway, remote_gateway, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__gateway_projection = None
        self.discriminator = None
        if gateway_projection is not None:
            self.__gateway_projection = gateway_projection

    def _initialize_object_type(self):
        return 'networking.v4.config.BgpSessionProjection'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def gateway_projection(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.GatewayProjection`
        """  # noqa: E501
        return self.__gateway_projection

    @gateway_projection.setter
    def gateway_projection(self, gateway_projection):

        self.__gateway_projection = gateway_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BgpSessionProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BgpSessionProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

