# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.networking.v4.config.IPv4Pool import IPv4Pool  # noqa: F401,E501

class IPPoolUsage(object):

    """IP pool Usage.

    :param num_free_i_ps: (:attr:`num_free_i_ps`) Number of free IPs.
    :type num_free_i_ps: 
    
     min=0,
    :param num_total_i_ps: (:attr:`num_total_i_ps`) Total number of IPs in this pool.
    :type num_total_i_ps: 
    
     min=0,
    :param range: (:attr:`range`) 
    :type range: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'num_free_i_ps': 'int',
        'num_total_i_ps': 'int',
        'range': 'networking.v4.config.IPv4Pool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'num_free_i_ps': 'numFreeIPs',
        'num_total_i_ps': 'numTotalIPs',
        'range': 'range',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, num_free_i_ps=None, num_total_i_ps=None, range=None, *args, **kwargs):  # noqa: E501
        self.__num_free_i_ps = None
        self.__num_total_i_ps = None
        self.__range = None
        self.discriminator = None
        if num_free_i_ps is not None:
            self.__num_free_i_ps = num_free_i_ps
        if num_total_i_ps is not None:
            self.__num_total_i_ps = num_total_i_ps
        if range is not None:
            self.__range = range
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.IPPoolUsage'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def num_free_i_ps(self):
        """
        Number of free IPs.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_free_i_ps

    @num_free_i_ps.setter
    def num_free_i_ps(self, num_free_i_ps):
        if num_free_i_ps is not None and num_free_i_ps < 0:  # noqa: E501
            raise ValueError("Invalid value for `num_free_i_ps`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__num_free_i_ps = num_free_i_ps

    @property
    def num_total_i_ps(self):
        """
        Total number of IPs in this pool.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__num_total_i_ps

    @num_total_i_ps.setter
    def num_total_i_ps(self, num_total_i_ps):
        if num_total_i_ps is not None and num_total_i_ps < 0:  # noqa: E501
            raise ValueError("Invalid value for `num_total_i_ps`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__num_total_i_ps = num_total_i_ps

    @property
    def range(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.IPv4Pool`
        """  # noqa: E501
        return self.__range

    @range.setter
    def range(self, range):

        self.__range = range

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(IPPoolUsage, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPPoolUsage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

