# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPv6Address import IPv6Address  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.IPv6Pool import IPv6Pool  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.IPv6Subnet import IPv6Subnet  # noqa: F401,E501

class IPv6Config(object):

    """IP V6 configuration.

    :param ip_subnet: (:attr:`ip_subnet`) 
    :type ip_subnet: required
    
    
    :param default_gateway_ip: (:attr:`default_gateway_ip`) 
    :type default_gateway_ip: 
    
    
    :param dhcp_server_address: (:attr:`dhcp_server_address`) 
    :type dhcp_server_address: 
    
    
    :param pool_list: (:attr:`pool_list`) Pool of IP addresses from where IPs are allocated.
    :type pool_list: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'ip_subnet': 'networking.v4.config.IPv6Subnet',
        'default_gateway_ip': 'common.v1.config.IPv6Address',
        'dhcp_server_address': 'common.v1.config.IPv6Address',
        'pool_list': 'list[networking.v4.config.IPv6Pool]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ip_subnet': 'ipSubnet',
        'default_gateway_ip': 'defaultGatewayIp',
        'dhcp_server_address': 'dhcpServerAddress',
        'pool_list': 'poolList',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ip_subnet=None, default_gateway_ip=None, dhcp_server_address=None, pool_list=None, *args, **kwargs):  # noqa: E501
        self.__ip_subnet = None
        self.__default_gateway_ip = None
        self.__dhcp_server_address = None
        self.__pool_list = None
        self.discriminator = None
        self.__ip_subnet = ip_subnet
        if default_gateway_ip is not None:
            self.__default_gateway_ip = default_gateway_ip
        if dhcp_server_address is not None:
            self.__dhcp_server_address = dhcp_server_address
        if pool_list is not None:
            self.__pool_list = pool_list
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.IPv6Config'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ip_subnet(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.IPv6Subnet`
        """  # noqa: E501
        return self.__ip_subnet

    @ip_subnet.setter
    def ip_subnet(self, ip_subnet):
        if ip_subnet is None:
            raise ValueError("Invalid value for `ip_subnet`, must not be `None`")  # noqa: E501

        self.__ip_subnet = ip_subnet

    @property
    def default_gateway_ip(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.common.v1.config.IPv6Address`
        """  # noqa: E501
        return self.__default_gateway_ip

    @default_gateway_ip.setter
    def default_gateway_ip(self, default_gateway_ip):

        self.__default_gateway_ip = default_gateway_ip

    @property
    def dhcp_server_address(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.common.v1.config.IPv6Address`
        """  # noqa: E501
        return self.__dhcp_server_address

    @dhcp_server_address.setter
    def dhcp_server_address(self, dhcp_server_address):

        self.__dhcp_server_address = dhcp_server_address

    @property
    def pool_list(self):
        """
        Pool of IP addresses from where IPs are allocated.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.networking.v4.config.IPv6Pool` ]
        """  # noqa: E501
        return self.__pool_list

    @pool_list.setter
    def pool_list(self, pool_list):

        self.__pool_list = pool_list

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(IPv6Config, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPv6Config):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

