# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.networking.v4.config.QuerierSpec import QuerierSpec  # noqa: F401,E501

class IgmpSpec(object):

    """Schema to configure IGMP Snooping on Virtual Switch

    :param is_snooping_enabled: (:attr:`is_snooping_enabled`) Enable IGMP snooping on this Virtual Switch (**Default** False)
    :type is_snooping_enabled: 
    
    
    :param querier_spec: (:attr:`querier_spec`) 
    :type querier_spec: 
    
    
    :param snooping_timeout: (:attr:`snooping_timeout`) IGMP Snooping timeout value in seconds (**Default** 300)
    :type snooping_timeout: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'is_snooping_enabled': 'bool',
        'querier_spec': 'networking.v4.config.QuerierSpec',
        'snooping_timeout': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_snooping_enabled': 'isSnoopingEnabled',
        'querier_spec': 'querierSpec',
        'snooping_timeout': 'snoopingTimeout',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_snooping_enabled=False, querier_spec=None, snooping_timeout=300, *args, **kwargs):  # noqa: E501
        self.__is_snooping_enabled = None
        self.__querier_spec = None
        self.__snooping_timeout = None
        self.discriminator = None
        if is_snooping_enabled is not None:
            self.__is_snooping_enabled = is_snooping_enabled
        if querier_spec is not None:
            self.__querier_spec = querier_spec
        if snooping_timeout is not None:
            self.__snooping_timeout = snooping_timeout
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.config.IgmpSpec'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_snooping_enabled(self):
        """
        Enable IGMP snooping on this Virtual Switch

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_snooping_enabled

    @is_snooping_enabled.setter
    def is_snooping_enabled(self, is_snooping_enabled):

        self.__is_snooping_enabled = is_snooping_enabled

    @property
    def querier_spec(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.QuerierSpec`
        """  # noqa: E501
        return self.__querier_spec

    @querier_spec.setter
    def querier_spec(self, querier_spec):

        self.__querier_spec = querier_spec

    @property
    def snooping_timeout(self):
        """
        IGMP Snooping timeout value in seconds

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__snooping_timeout

    @snooping_timeout.setter
    def snooping_timeout(self, snooping_timeout):

        self.__snooping_timeout = snooping_timeout

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(IgmpSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IgmpSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

