# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.MacAddress import MacAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.MacType import MacType  # noqa: F401,E501

class LearnedMacAddress(MacAddress):

    """Layer2 Stretch MAC address properties.

    :param remote_gateway_reference: (:attr:`remote_gateway_reference`) A reference to the associated remote VTEP Gateway.
    :type remote_gateway_reference: 
    
    
    :param vtep_ip_address: (:attr:`vtep_ip_address`) 
    :type vtep_ip_address: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'remote_gateway_reference': 'str',
        'vtep_ip_address': 'common.v1.config.IPAddress',
        'value': 'str',
        'mac_type': 'networking.v4.config.MacType',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'remote_gateway_reference': 'remoteGatewayReference',
        'vtep_ip_address': 'vtepIPAddress',
        'value': 'value',
        'mac_type': 'macType',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, remote_gateway_reference=None, vtep_ip_address=None, value=None, mac_type=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        MacAddress.__init__(self, value, mac_type, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__remote_gateway_reference = None
        self.__vtep_ip_address = None
        self.discriminator = None
        if remote_gateway_reference is not None:
            self.__remote_gateway_reference = remote_gateway_reference
        if vtep_ip_address is not None:
            self.__vtep_ip_address = vtep_ip_address

    def _initialize_object_type(self):
        return 'networking.v4.config.LearnedMacAddress'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def remote_gateway_reference(self):
        """
        A reference to the associated remote VTEP Gateway.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__remote_gateway_reference

    @remote_gateway_reference.setter
    def remote_gateway_reference(self, remote_gateway_reference):
        if remote_gateway_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', remote_gateway_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `remote_gateway_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__remote_gateway_reference = remote_gateway_reference

    @property
    def vtep_ip_address(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__vtep_ip_address

    @vtep_ip_address.setter
    def vtep_ip_address(self, vtep_ip_address):

        self.__vtep_ip_address = vtep_ip_address

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(LearnedMacAddress, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LearnedMacAddress):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

