# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.CloudSubstrate import CloudSubstrate  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.ControllerStatus import ControllerStatus  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.DefaultVlanStack import DefaultVlanStack  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501

class NetworkController(NetworkingBaseModel):

    """

    :param controller_status: (:attr:`controller_status`) 
    :type controller_status: 
    
    
    :param controller_version: (:attr:`controller_version`) Network controller software version.
    :type controller_version: 
    
    
    :param minimum_ahv_version: (:attr:`minimum_ahv_version`) Minimum AHV version that this network controller supports.
    :type minimum_ahv_version: 
    
    
    :param minimum_nos_version: (:attr:`minimum_nos_version`) Minimum NOS version that this network controller supports.
    :type minimum_nos_version: 
    
    
    :param cloud_substrate: (:attr:`cloud_substrate`) 
    :type cloud_substrate: 
    
    
    :param default_vlan_stack: (:attr:`default_vlan_stack`) 
    :type default_vlan_stack: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'controller_status': 'networking.v4.config.ControllerStatus',
        'controller_version': 'str',
        'minimum_ahv_version': 'str',
        'minimum_nos_version': 'str',
        'cloud_substrate': 'networking.v4.config.CloudSubstrate',
        'default_vlan_stack': 'networking.v4.config.DefaultVlanStack',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'controller_status': 'controllerStatus',
        'controller_version': 'controllerVersion',
        'minimum_ahv_version': 'minimumAHVVersion',
        'minimum_nos_version': 'minimumNOSVersion',
        'cloud_substrate': 'cloudSubstrate',
        'default_vlan_stack': 'defaultVlanStack',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, controller_status=None, controller_version=None, minimum_ahv_version=None, minimum_nos_version=None, cloud_substrate=None, default_vlan_stack=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__controller_status = None
        self.__controller_version = None
        self.__minimum_ahv_version = None
        self.__minimum_nos_version = None
        self.__cloud_substrate = None
        self.__default_vlan_stack = None
        self.discriminator = None
        if controller_status is not None:
            self.__controller_status = controller_status
        if controller_version is not None:
            self.__controller_version = controller_version
        if minimum_ahv_version is not None:
            self.__minimum_ahv_version = minimum_ahv_version
        if minimum_nos_version is not None:
            self.__minimum_nos_version = minimum_nos_version
        if cloud_substrate is not None:
            self.__cloud_substrate = cloud_substrate
        if default_vlan_stack is not None:
            self.__default_vlan_stack = default_vlan_stack

    def _initialize_object_type(self):
        return 'networking.v4.config.NetworkController'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def controller_status(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.ControllerStatus`
        """  # noqa: E501
        return self.__controller_status

    @controller_status.setter
    def controller_status(self, controller_status):

        self.__controller_status = controller_status

    @property
    def controller_version(self):
        """
        Network controller software version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__controller_version

    @controller_version.setter
    def controller_version(self, controller_version):

        self.__controller_version = controller_version

    @property
    def minimum_ahv_version(self):
        """
        Minimum AHV version that this network controller supports.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__minimum_ahv_version

    @minimum_ahv_version.setter
    def minimum_ahv_version(self, minimum_ahv_version):

        self.__minimum_ahv_version = minimum_ahv_version

    @property
    def minimum_nos_version(self):
        """
        Minimum NOS version that this network controller supports.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__minimum_nos_version

    @minimum_nos_version.setter
    def minimum_nos_version(self, minimum_nos_version):

        self.__minimum_nos_version = minimum_nos_version

    @property
    def cloud_substrate(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.CloudSubstrate`
        """  # noqa: E501
        return self.__cloud_substrate

    @cloud_substrate.setter
    def cloud_substrate(self, cloud_substrate):

        self.__cloud_substrate = cloud_substrate

    @property
    def default_vlan_stack(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.DefaultVlanStack`
        """  # noqa: E501
        return self.__default_vlan_stack

    @default_vlan_stack.setter
    def default_vlan_stack(self, default_vlan_stack):

        self.__default_vlan_stack = default_vlan_stack

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NetworkController, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkController):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

