# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_networking_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class ReservedIp(ExternalizableAbstractModel):

    """Information pertaining to a reserved IP address on a subnet.

    :param ipv4_address: (:attr:`ipv4_address`) Reserved IPv4 address.
    :type ipv4_address: 
    
    
    :param client_context: (:attr:`client_context`) Optional context to associate with a reserved IP address.
    :type client_context: 
     min=1 chars, max=64 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'ipv4_address': 'str',
        'client_context': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ipv4_address': 'ipv4Address',
        'client_context': 'clientContext',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ipv4_address=None, client_context=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__ipv4_address = None
        self.__client_context = None
        self.discriminator = None
        if ipv4_address is not None:
            self.__ipv4_address = ipv4_address
        if client_context is not None:
            self.__client_context = client_context

    def _initialize_object_type(self):
        return 'networking.v4.config.ReservedIp'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def ipv4_address(self):
        """
        Reserved IPv4 address.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__ipv4_address

    @ipv4_address.setter
    def ipv4_address(self, ipv4_address):

        self.__ipv4_address = ipv4_address

    @property
    def client_context(self):
        """
        Optional context to associate with a reserved IP address.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__client_context

    @client_context.setter
    def client_context(self, client_context):
        if client_context is not None and len(client_context) > 64:
            raise ValueError("Invalid value for `client_context`, length must be less than or equal to `64`")  # noqa: E501
        if client_context is not None and len(client_context) < 1:
            raise ValueError("Invalid value for `client_context`, length must be greater than or equal to `1`")  # noqa: E501

        self.__client_context = client_context

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ReservedIp, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReservedIp):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

