# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.DhcpOptions import DhcpOptions  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.IPConfig import IPConfig  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.IPUsage import IPUsage  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.MigrationState import MigrationState  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.SubnetType import SubnetType  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.VirtualSwitch import VirtualSwitch  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.Vpc import Vpc  # noqa: F401,E501

class Subnet(NetworkingBaseModel):

    """API schema for subnet.

    :param name: (:attr:`name`) Name of the subnet.
    :type name: 
     max=128 chars
    
    :param description: (:attr:`description`) Description of the subnet.
    :type description: 
     max=1000 chars
    
    :param subnet_type: (:attr:`subnet_type`) 
    :type subnet_type: 
    
    
    :param network_id: (:attr:`network_id`) For VLAN subnet, this field represents VLAN Id, valid range is from 0 to 4095; For overlay subnet, this field represents 24-bit VNI, this field is read-only.
    :type network_id: 
    
     min=0, max=16777215
    :param dhcp_options: (:attr:`dhcp_options`) 
    :type dhcp_options: 
    
    
    :param ip_config: (:attr:`ip_config`) IP configuration for the subnet.
    :type ip_config: 
    
    
    :param cluster_reference: (:attr:`cluster_reference`) UUID of the cluster this subnet belongs to.
    :type cluster_reference: 
    
    
    :param virtual_switch_reference: (:attr:`virtual_switch_reference`) UUID of the virtual switch this subnet belongs to (type VLAN only).
    :type virtual_switch_reference: 
    
    
    :param vpc_reference: (:attr:`vpc_reference`) UUID of Virtual Private Cloud this subnet belongs to (type Overlay only).
    :type vpc_reference: 
    
    
    :param is_nat_enabled: (:attr:`is_nat_enabled`) Indicates whether NAT must be enabled for VPCs attached to the subnet. This is supported only for external subnets. NAT is enabled by default on external subnets.
    :type is_nat_enabled: 
    
    
    :param is_external: (:attr:`is_external`) Indicates whether the subnet is used for external connectivity.
    :type is_external: 
    
    
    :param reserved_ip_addresses: (:attr:`reserved_ip_addresses`) List of IPs that are excluded while allocating IP addresses to VM ports.
    :type reserved_ip_addresses: 
    
    
    :param dynamic_ip_addresses: (:attr:`dynamic_ip_addresses`) List of IPs, which are a subset from the reserved IP address list, that must be advertised to the SDN gateway.
    :type dynamic_ip_addresses: 
    
    
    :param network_function_chain_reference: (:attr:`network_function_chain_reference`) UUID of the Network function chain entity that this subnet belongs to (type VLAN only).
    :type network_function_chain_reference: 
    
    
    :param bridge_name: (:attr:`bridge_name`) Name of the bridge on the host for the subnet.
    :type bridge_name: 
     max=128 chars
    
    :param is_advanced_networking: (:attr:`is_advanced_networking`) Indicates whether the subnet is used for advanced networking.
    :type is_advanced_networking: 
    
    
    :param cluster_name: (:attr:`cluster_name`) Cluster Name
    :type cluster_name: 
     max=128 chars
    
    :param hypervisor_type: (:attr:`hypervisor_type`) Hypervisor Type
    :type hypervisor_type: 
    
    
    :param virtual_switch: (:attr:`virtual_switch`) 
    :type virtual_switch: 
    
    
    :param vpc: (:attr:`vpc`) 
    :type vpc: 
    
    
    :param ip_prefix: (:attr:`ip_prefix`) IP Prefix in CIDR format.
    :type ip_prefix: 
    
    
    :param ip_usage: (:attr:`ip_usage`) 
    :type ip_usage: 
    
    
    :param migration_state: (:attr:`migration_state`) 
    :type migration_state: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'subnet_type': 'networking.v4.config.SubnetType',
        'network_id': 'int',
        'dhcp_options': 'networking.v4.config.DhcpOptions',
        'ip_config': 'list[networking.v4.config.IPConfig]',
        'cluster_reference': 'str',
        'virtual_switch_reference': 'str',
        'vpc_reference': 'str',
        'is_nat_enabled': 'bool',
        'is_external': 'bool',
        'reserved_ip_addresses': 'list[common.v1.config.IPAddress]',
        'dynamic_ip_addresses': 'list[common.v1.config.IPAddress]',
        'network_function_chain_reference': 'str',
        'bridge_name': 'str',
        'is_advanced_networking': 'bool',
        'cluster_name': 'str',
        'hypervisor_type': 'str',
        'virtual_switch': 'networking.v4.config.VirtualSwitch',
        'vpc': 'networking.v4.config.Vpc',
        'ip_prefix': 'str',
        'ip_usage': 'networking.v4.config.IPUsage',
        'migration_state': 'networking.v4.config.MigrationState',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'subnet_type': 'subnetType',
        'network_id': 'networkId',
        'dhcp_options': 'dhcpOptions',
        'ip_config': 'ipConfig',
        'cluster_reference': 'clusterReference',
        'virtual_switch_reference': 'virtualSwitchReference',
        'vpc_reference': 'vpcReference',
        'is_nat_enabled': 'isNatEnabled',
        'is_external': 'isExternal',
        'reserved_ip_addresses': 'reservedIpAddresses',
        'dynamic_ip_addresses': 'dynamicIpAddresses',
        'network_function_chain_reference': 'networkFunctionChainReference',
        'bridge_name': 'bridgeName',
        'is_advanced_networking': 'isAdvancedNetworking',
        'cluster_name': 'clusterName',
        'hypervisor_type': 'hypervisorType',
        'virtual_switch': 'virtualSwitch',
        'vpc': 'vpc',
        'ip_prefix': 'ipPrefix',
        'ip_usage': 'ipUsage',
        'migration_state': 'migrationState',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, subnet_type=None, network_id=None, dhcp_options=None, ip_config=None, cluster_reference=None, virtual_switch_reference=None, vpc_reference=None, is_nat_enabled=None, is_external=None, reserved_ip_addresses=None, dynamic_ip_addresses=None, network_function_chain_reference=None, bridge_name=None, is_advanced_networking=None, cluster_name=None, hypervisor_type=None, virtual_switch=None, vpc=None, ip_prefix=None, ip_usage=None, migration_state=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__subnet_type = None
        self.__network_id = None
        self.__dhcp_options = None
        self.__ip_config = None
        self.__cluster_reference = None
        self.__virtual_switch_reference = None
        self.__vpc_reference = None
        self.__is_nat_enabled = None
        self.__is_external = None
        self.__reserved_ip_addresses = None
        self.__dynamic_ip_addresses = None
        self.__network_function_chain_reference = None
        self.__bridge_name = None
        self.__is_advanced_networking = None
        self.__cluster_name = None
        self.__hypervisor_type = None
        self.__virtual_switch = None
        self.__vpc = None
        self.__ip_prefix = None
        self.__ip_usage = None
        self.__migration_state = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if subnet_type is not None:
            self.__subnet_type = subnet_type
        if network_id is not None:
            self.__network_id = network_id
        if dhcp_options is not None:
            self.__dhcp_options = dhcp_options
        if ip_config is not None:
            self.__ip_config = ip_config
        if cluster_reference is not None:
            self.__cluster_reference = cluster_reference
        if virtual_switch_reference is not None:
            self.__virtual_switch_reference = virtual_switch_reference
        if vpc_reference is not None:
            self.__vpc_reference = vpc_reference
        if is_nat_enabled is not None:
            self.__is_nat_enabled = is_nat_enabled
        if is_external is not None:
            self.__is_external = is_external
        if reserved_ip_addresses is not None:
            self.__reserved_ip_addresses = reserved_ip_addresses
        if dynamic_ip_addresses is not None:
            self.__dynamic_ip_addresses = dynamic_ip_addresses
        if network_function_chain_reference is not None:
            self.__network_function_chain_reference = network_function_chain_reference
        if bridge_name is not None:
            self.__bridge_name = bridge_name
        if is_advanced_networking is not None:
            self.__is_advanced_networking = is_advanced_networking
        if cluster_name is not None:
            self.__cluster_name = cluster_name
        if hypervisor_type is not None:
            self.__hypervisor_type = hypervisor_type
        if virtual_switch is not None:
            self.__virtual_switch = virtual_switch
        if vpc is not None:
            self.__vpc = vpc
        if ip_prefix is not None:
            self.__ip_prefix = ip_prefix
        if ip_usage is not None:
            self.__ip_usage = ip_usage
        if migration_state is not None:
            self.__migration_state = migration_state

    def _initialize_object_type(self):
        return 'networking.v4.config.Subnet'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def name(self):
        """
        Name of the subnet.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Description of the subnet.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def subnet_type(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.SubnetType`
        """  # noqa: E501
        return self.__subnet_type

    @subnet_type.setter
    def subnet_type(self, subnet_type):

        self.__subnet_type = subnet_type

    @property
    def network_id(self):
        """
        For VLAN subnet, this field represents VLAN Id, valid range is from 0 to 4095; For overlay subnet, this field represents 24-bit VNI, this field is read-only.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__network_id

    @network_id.setter
    def network_id(self, network_id):
        if network_id is not None and network_id > 16777215:  # noqa: E501
            raise ValueError("Invalid value for `network_id`, must be a value less than or equal to `16777215`")  # noqa: E501
        if network_id is not None and network_id < 0:  # noqa: E501
            raise ValueError("Invalid value for `network_id`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__network_id = network_id

    @property
    def dhcp_options(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.DhcpOptions`
        """  # noqa: E501
        return self.__dhcp_options

    @dhcp_options.setter
    def dhcp_options(self, dhcp_options):

        self.__dhcp_options = dhcp_options

    @property
    def ip_config(self):
        """
        IP configuration for the subnet.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.networking.v4.config.IPConfig` ]
        """  # noqa: E501
        return self.__ip_config

    @ip_config.setter
    def ip_config(self, ip_config):

        self.__ip_config = ip_config

    @property
    def cluster_reference(self):
        """
        UUID of the cluster this subnet belongs to.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_reference

    @cluster_reference.setter
    def cluster_reference(self, cluster_reference):
        if cluster_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_reference = cluster_reference

    @property
    def virtual_switch_reference(self):
        """
        UUID of the virtual switch this subnet belongs to (type VLAN only).

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__virtual_switch_reference

    @virtual_switch_reference.setter
    def virtual_switch_reference(self, virtual_switch_reference):
        if virtual_switch_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', virtual_switch_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `virtual_switch_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__virtual_switch_reference = virtual_switch_reference

    @property
    def vpc_reference(self):
        """
        UUID of Virtual Private Cloud this subnet belongs to (type Overlay only).

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__vpc_reference

    @vpc_reference.setter
    def vpc_reference(self, vpc_reference):
        if vpc_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', vpc_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `vpc_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__vpc_reference = vpc_reference

    @property
    def is_nat_enabled(self):
        """
        Indicates whether NAT must be enabled for VPCs attached to the subnet. This is supported only for external subnets. NAT is enabled by default on external subnets.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_nat_enabled

    @is_nat_enabled.setter
    def is_nat_enabled(self, is_nat_enabled):

        self.__is_nat_enabled = is_nat_enabled

    @property
    def is_external(self):
        """
        Indicates whether the subnet is used for external connectivity.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_external

    @is_external.setter
    def is_external(self, is_external):

        self.__is_external = is_external

    @property
    def reserved_ip_addresses(self):
        """
        List of IPs that are excluded while allocating IP addresses to VM ports.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__reserved_ip_addresses

    @reserved_ip_addresses.setter
    def reserved_ip_addresses(self, reserved_ip_addresses):

        self.__reserved_ip_addresses = reserved_ip_addresses

    @property
    def dynamic_ip_addresses(self):
        """
        List of IPs, which are a subset from the reserved IP address list, that must be advertised to the SDN gateway.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__dynamic_ip_addresses

    @dynamic_ip_addresses.setter
    def dynamic_ip_addresses(self, dynamic_ip_addresses):

        self.__dynamic_ip_addresses = dynamic_ip_addresses

    @property
    def network_function_chain_reference(self):
        """
        UUID of the Network function chain entity that this subnet belongs to (type VLAN only).

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__network_function_chain_reference

    @network_function_chain_reference.setter
    def network_function_chain_reference(self, network_function_chain_reference):
        if network_function_chain_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', network_function_chain_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `network_function_chain_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__network_function_chain_reference = network_function_chain_reference

    @property
    def bridge_name(self):
        """
        Name of the bridge on the host for the subnet.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__bridge_name

    @bridge_name.setter
    def bridge_name(self, bridge_name):
        if bridge_name is not None and len(bridge_name) > 128:
            raise ValueError("Invalid value for `bridge_name`, length must be less than or equal to `128`")  # noqa: E501

        self.__bridge_name = bridge_name

    @property
    def is_advanced_networking(self):
        """
        Indicates whether the subnet is used for advanced networking.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_advanced_networking

    @is_advanced_networking.setter
    def is_advanced_networking(self, is_advanced_networking):

        self.__is_advanced_networking = is_advanced_networking

    @property
    def cluster_name(self):
        """
        Cluster Name

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_name

    @cluster_name.setter
    def cluster_name(self, cluster_name):
        if cluster_name is not None and len(cluster_name) > 128:
            raise ValueError("Invalid value for `cluster_name`, length must be less than or equal to `128`")  # noqa: E501

        self.__cluster_name = cluster_name

    @property
    def hypervisor_type(self):
        """
        Hypervisor Type

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__hypervisor_type

    @hypervisor_type.setter
    def hypervisor_type(self, hypervisor_type):

        self.__hypervisor_type = hypervisor_type

    @property
    def virtual_switch(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.VirtualSwitch`
        """  # noqa: E501
        return self.__virtual_switch

    @virtual_switch.setter
    def virtual_switch(self, virtual_switch):

        self.__virtual_switch = virtual_switch

    @property
    def vpc(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.Vpc`
        """  # noqa: E501
        return self.__vpc

    @vpc.setter
    def vpc(self, vpc):

        self.__vpc = vpc

    @property
    def ip_prefix(self):
        """
        IP Prefix in CIDR format.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__ip_prefix

    @ip_prefix.setter
    def ip_prefix(self, ip_prefix):

        self.__ip_prefix = ip_prefix

    @property
    def ip_usage(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.IPUsage`
        """  # noqa: E501
        return self.__ip_usage

    @ip_usage.setter
    def ip_usage(self, ip_usage):

        self.__ip_usage = ip_usage

    @property
    def migration_state(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.MigrationState`
        """  # noqa: E501
        return self.__migration_state

    @migration_state.setter
    def migration_state(self, migration_state):

        self.__migration_state = migration_state

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Subnet, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Subnet):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

