# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.networking.v4.config.TrafficMirrorPort import TrafficMirrorPort  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.TrafficMirrorPortNicType import TrafficMirrorPortNicType  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.TrafficMirrorSourcePortDirection import TrafficMirrorSourcePortDirection  # noqa: F401,E501

class TrafficMirrorSourcePort(TrafficMirrorPort):

    """Traffic mirror session source port to mirror traffic from.

    :param direction: (:attr:`direction`) 
    :type direction: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'direction': 'networking.v4.config.TrafficMirrorSourcePortDirection',
        'nic_type': 'networking.v4.config.TrafficMirrorPortNicType',
        'nic_uuid': 'str',
        'is_up': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'direction': 'direction',
        'nic_type': 'nicType',
        'nic_uuid': 'nicUuid',
        'is_up': 'isUp',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, direction=None, nic_type=None, nic_uuid=None, is_up=None, *args, **kwargs):  # noqa: E501
        TrafficMirrorPort.__init__(self, nic_type, nic_uuid, is_up, *args, **kwargs)
        self.__direction = None
        self.discriminator = None
        self.__direction = direction

    def _initialize_object_type(self):
        return 'networking.v4.config.TrafficMirrorSourcePort'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def direction(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.TrafficMirrorSourcePortDirection`
        """  # noqa: E501
        return self.__direction

    @direction.setter
    def direction(self, direction):
        if direction is None:
            raise ValueError("Invalid value for `direction`, must not be `None`")  # noqa: E501

        self.__direction = direction

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(TrafficMirrorSourcePort, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TrafficMirrorSourcePort):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

