# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_networking_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501

class Vnic(NetworkingBaseModel):

    """Virtual NIC object.

    :param learned_ipv4_addresses: (:attr:`learned_ipv4_addresses`) The learned IPv4 addresses on the virtual NIC.
    :type learned_ipv4_addresses: 
    
    
    :param assigned_ipv4_addresses: (:attr:`assigned_ipv4_addresses`) The assigned IPv4 addresses on the virtual NIC.
    :type assigned_ipv4_addresses: 
    
    
    :param assigned_secondary_ipv4_addresses: (:attr:`assigned_secondary_ipv4_addresses`) The assigned secondary IPv4 addresses on the virtual NIC.
    :type assigned_secondary_ipv4_addresses: 
    
    
    :param mac_address: (:attr:`mac_address`) The MAC address assigned to the virtual NIC.
    :type mac_address: 
    
    
    :param vm_reference: (:attr:`vm_reference`) The VM UUID of the virtual NIC.
    :type vm_reference: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'learned_ipv4_addresses': 'list[common.v1.config.IPAddress]',
        'assigned_ipv4_addresses': 'list[common.v1.config.IPAddress]',
        'assigned_secondary_ipv4_addresses': 'list[common.v1.config.IPAddress]',
        'mac_address': 'str',
        'vm_reference': 'str',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'learned_ipv4_addresses': 'learnedIpv4Addresses',
        'assigned_ipv4_addresses': 'assignedIpv4Addresses',
        'assigned_secondary_ipv4_addresses': 'assignedSecondaryIpv4Addresses',
        'mac_address': 'macAddress',
        'vm_reference': 'vmReference',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, learned_ipv4_addresses=None, assigned_ipv4_addresses=None, assigned_secondary_ipv4_addresses=None, mac_address=None, vm_reference=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__learned_ipv4_addresses = None
        self.__assigned_ipv4_addresses = None
        self.__assigned_secondary_ipv4_addresses = None
        self.__mac_address = None
        self.__vm_reference = None
        self.discriminator = None
        if learned_ipv4_addresses is not None:
            self.__learned_ipv4_addresses = learned_ipv4_addresses
        if assigned_ipv4_addresses is not None:
            self.__assigned_ipv4_addresses = assigned_ipv4_addresses
        if assigned_secondary_ipv4_addresses is not None:
            self.__assigned_secondary_ipv4_addresses = assigned_secondary_ipv4_addresses
        if mac_address is not None:
            self.__mac_address = mac_address
        if vm_reference is not None:
            self.__vm_reference = vm_reference

    def _initialize_object_type(self):
        return 'networking.v4.config.Vnic'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def learned_ipv4_addresses(self):
        """
        The learned IPv4 addresses on the virtual NIC.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__learned_ipv4_addresses

    @learned_ipv4_addresses.setter
    def learned_ipv4_addresses(self, learned_ipv4_addresses):

        self.__learned_ipv4_addresses = learned_ipv4_addresses

    @property
    def assigned_ipv4_addresses(self):
        """
        The assigned IPv4 addresses on the virtual NIC.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__assigned_ipv4_addresses

    @assigned_ipv4_addresses.setter
    def assigned_ipv4_addresses(self, assigned_ipv4_addresses):

        self.__assigned_ipv4_addresses = assigned_ipv4_addresses

    @property
    def assigned_secondary_ipv4_addresses(self):
        """
        The assigned secondary IPv4 addresses on the virtual NIC.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__assigned_secondary_ipv4_addresses

    @assigned_secondary_ipv4_addresses.setter
    def assigned_secondary_ipv4_addresses(self, assigned_secondary_ipv4_addresses):

        self.__assigned_secondary_ipv4_addresses = assigned_secondary_ipv4_addresses

    @property
    def mac_address(self):
        """
        The MAC address assigned to the virtual NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        if mac_address is not None and not re.search('^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$', mac_address):  # noqa: E501
            raise ValueError(r"Invalid value for `mac_address`, must be a follow pattern or equal to `/^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$/`")  # noqa: E501

        self.__mac_address = mac_address

    @property
    def vm_reference(self):
        """
        The VM UUID of the virtual NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__vm_reference

    @vm_reference.setter
    def vm_reference(self, vm_reference):
        if vm_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', vm_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `vm_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__vm_reference = vm_reference

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Vnic, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Vnic):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

