# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class TargetStats(object):

    """

    :param virtual_nic_reference: (:attr:`virtual_nic_reference`) Load balancer session Target vNIC reference.
    :type virtual_nic_reference: 
    
    
    :param num_bytes: (:attr:`num_bytes`) String array of number of bytes received.
    :type num_bytes: 
    
    
    :param num_requests: (:attr:`num_requests`) String array of number of packets received.
    :type num_requests: 
    
    
    :param num_packets: (:attr:`num_packets`) String array of number of requests received.
    :type num_packets: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'virtual_nic_reference': 'str',
        'num_bytes': 'list[str]',
        'num_requests': 'list[str]',
        'num_packets': 'list[str]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'virtual_nic_reference': 'virtualNicReference',
        'num_bytes': 'numBytes',
        'num_requests': 'numRequests',
        'num_packets': 'numPackets',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, virtual_nic_reference=None, num_bytes=None, num_requests=None, num_packets=None, *args, **kwargs):  # noqa: E501
        self.__virtual_nic_reference = None
        self.__num_bytes = None
        self.__num_requests = None
        self.__num_packets = None
        self.discriminator = None
        if virtual_nic_reference is not None:
            self.__virtual_nic_reference = virtual_nic_reference
        if num_bytes is not None:
            self.__num_bytes = num_bytes
        if num_requests is not None:
            self.__num_requests = num_requests
        if num_packets is not None:
            self.__num_packets = num_packets
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'networking.v4.stats.TargetStats'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def virtual_nic_reference(self):
        """
        Load balancer session Target vNIC reference.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__virtual_nic_reference

    @virtual_nic_reference.setter
    def virtual_nic_reference(self, virtual_nic_reference):
        if virtual_nic_reference is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', virtual_nic_reference):  # noqa: E501
            raise ValueError(r"Invalid value for `virtual_nic_reference`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__virtual_nic_reference = virtual_nic_reference

    @property
    def num_bytes(self):
        """
        String array of number of bytes received.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__num_bytes

    @num_bytes.setter
    def num_bytes(self, num_bytes):

        self.__num_bytes = num_bytes

    @property
    def num_requests(self):
        """
        String array of number of packets received.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__num_requests

    @num_requests.setter
    def num_requests(self, num_requests):

        self.__num_requests = num_requests

    @property
    def num_packets(self):
        """
        String array of number of requests received.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__num_packets

    @num_packets.setter
    def num_packets(self, num_packets):

        self.__num_packets = num_packets

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(TargetStats, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TargetStats):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

